# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

#TODO: BR: perl(Test::Pod::LinkCheck) when available

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION < 6.30) ? 1 : 0);' 2>/dev/null || echo 0)

# We need a recent version of Test::More
%global quite_old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION) < 0.96 ? 1 : 0);' 2>/dev/null || echo 0)

# noarch, but to avoid debug* files interfering with manifest test:
%global debug_package %{nil}

Name:		perl-Pod-Spell
Version:	1.13
Release:	1.%{__distinit}%{__distvers}
Summary:	A formatter for spell-checking Pod
Group:		Development/Libraries
License:	Artistic 2.0
URL:		http://search.cpan.org/dist/Pod-Spell/
Source0:	http://search.cpan.org/CPAN/authors/id/X/XE/XENO/Pod-Spell-%{version}.tar.gz
Source1:	File-Temp-0.21.pm
Source2:	T-M-0.96.tar.gz
Patch1:		Pod-Spell-1.10-old-EU::MM.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::ShareDir::Install) >= 0.03
# Module
BuildRequires:	perl(base)
BuildRequires:	perl(Carp)
BuildRequires:	perl(Class::Tiny)
BuildRequires:	perl(constant)
BuildRequires:	perl(File::ShareDir::ProjectDistDir)
BuildRequires:	perl(File::Slurp)
BuildRequires:	perl(Lingua::EN::Inflect)
BuildRequires:	perl(Pod::Escapes) >= 1.01
BuildRequires:	perl(Pod::Parser)
BuildRequires:	perl(Text::Wrap)
BuildRequires:	perl(utf8)
# Test Suite
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(IO::Handle)
BuildRequires:	perl(IPC::Open3)
BuildRequires:	perl(Test::Deep)
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Script)
# Author and Release Tests
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Pod::Coverage::TrustPod)
# Test::CPAN::Changes only available if we have Perl 5.10.0 onwards
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
BuildRequires:	perl(Test::CPAN::Changes) >= 0.19
%endif
BuildRequires:	perl(Test::CPAN::Meta)
BuildRequires:	perl(Test::CPAN::Meta::JSON)
BuildRequires:	perl(Test::DistManifest)
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::MinimumVersion)
BuildRequires:	perl(Test::Mojibake)
BuildRequires:	perl(Test::Perl::Critic)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Portability::Files)
BuildRequires:	perl(Test::Spelling), aspell-en
# Test::Vars only available if we have Perl 5.10.0 onwards
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
BuildRequires:	perl(Test::Vars)
%endif
BuildRequires:	perl(Test::Version)
BuildRequires:	perl(version) >= 0.99
%endif
# Runtime
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
Pod::Spell is a Pod formatter whose output is good for spell-checking.
Pod::Spell rather like Pod::Text, except that it doesn't put much
effort into actual formatting, and it suppresses things that look like
Perl symbols or Perl jargon (so that your spell-checking program won't
complain about mystery words like "$thing" or "Foo::Bar" or "hashref").

%prep
%setup -q -n Pod-Spell-%{version}

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%if %{old_eumm}
%patch1
%endif

# Use of subtests requires Test::More ≥ 0.96; use a bundled version if we don't have it
%if %{quite_old_test_more}
tar xfz %{SOURCE2}
find inc -type f >> MANIFEST
%endif

# File::Temp 0.17 is needed for the seek method (just for the test suite)
%if %(perl -MFile::Temp -e 'print $File::Temp::VERSION < 0.17 ? 1 : 0;')
mkdir -p inc/File
cp -p %{SOURCE1} inc/File/Temp.pm
echo inc/File/Temp.pm >> MANIFEST
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
%{_fixperms} %{buildroot}

%check
# Use our local File::Temp/Test::More if necessary
[ -d inc/ ] && export PERL5LIB=$(pwd)/inc

# Set locale appropriately for spelling test
export LANG=en_US.UTF-8

%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
make test %{!?perl_bootstrap:AUTHOR_TESTING=1 RELEASE_TESTING=1}
%else
make test %{!?perl_bootstrap:AUTHOR_TESTING=1 RELEASE_TESTING=1} TEST_FILES="$(echo $(find t/ -name '*.t' | grep -Fv cpan-changes.t))"
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc CONTRIBUTING Changes LICENSE README
%{_bindir}/podspell
%{perl_vendorlib}/Pod/
%{perl_vendorlib}/auto/share/
%{_mandir}/man1/podspell.1*
%{_mandir}/man3/Pod::Spell.3pm*
%{_mandir}/man3/Pod::Wordlist.3pm*

%changelog
* Sun Nov  3 2013 Paul Howarth <paul@city-fan.org> - 1.13-1
- Update to 1.13
  - Fix encoding issues issues in pod for perldoc
- Drop upstreamed UTF8 patch

* Fri Oct 18 2013 Paul Howarth <paul@city-fan.org> - 1.12-1
- Update to 1.12
  - Fix shebang to /usr/bin/perl for EUMM replacment (GH #13)
  - Improve documentation

* Sat Sep 28 2013 Paul Howarth <paul@city-fan.org> - 1.10-1
- Update to 1.10
  - Added 'no_wide_chars' option to strip words with such characters from the
    output; this may help spellcheckers that can't cope with UTF-8
  - Improved punctuation stripping algorithm for better word isolation
    (example C<< "hello". >> now is found as "hello")
  - Strips all word that do not have at least one \w character as a
    spellchecker isn't likely to do anything useful with them
  - Added recommendations for dealing with character encoding
- Drop patches from upstream

* Fri Sep 27 2013 Paul Howarth <paul@city-fan.org> - 1.09-2
- Update to 1.09
  - Stopwords with 's are learned without 's to match how they are checked
  - Leading and trailing punctuation is entirely stripped since the spell
    checker won't care anyway; trailing periods are *not* stripped as they
    might be abbreviations ("Ph.D."), but such words are checked against the
    stoplist both with and without trailing periods to account for
    abbreviations and words at the end of a sentence
- Kwalitee and Mojibake tests dropped by upstream
- Add patches from upstream to address various encoding/stopword issues
  - https://github.com/xenoterracide/Pod-Spell/issues/9
  - https://github.com/xenoterracide/Pod-Spell/issues/11

* Wed Sep 25 2013 Paul Howarth <paul@city-fan.org> - 1.08-1
- Update to 1.08
  - Hyphenated word parts are also checked against the stoplist and stripped
  - Documented that stopwords must be added before words appear in Pod

* Sun Sep 15 2013 Paul Howarth <paul@city-fan.org> - 1.07-1
- Update to 1.07
  - Add many words
  - Pod::Wordlist is an Object
  - Lingua::EN::Inflect is used to reduce requiring plurals in the list
  - The wordlist is now a sharedir file
  - Accessing %%Pod::Wordlist::Wordlist directly is now deprecated
- BR: perl(File::ShareDir::Install) ≥ 0.03 for the build process
- BR: perl(Class::Tiny), perl(File::ShareDir::ProjectDistDir),
  perl(File::Slurp) and perl(Lingua::EN::Inflect) for the module runtime
- Update patch for supporting building with ExtUtils::MakeMaker < 6.30

* Sun Sep  8 2013 Paul Howarth <paul@city-fan.org> - 1.06-1
- Update to 1.06
  - Import stopwords from Pod::Wordlist::hanekomu except names
- Add patch to support building with ExtUtils::MakeMaker < 6.30
- If we don't have a recent enough Test::More, use a bundled one instead; this
  is _so_ much simpler than patching out the modern bits
- Take the same approach with File::Temp; we can now support old distributions
  back to FC-3

* Fri Jul 19 2013 Paul Howarth <paul@city-fan.org> - 1.05-2
- Perl 5.18 rebuild

* Sun Jul  7 2013 Paul Howarth <paul@city-fan.org> - 1.05-1
- Update to 1.05
  - Add stopwords

* Thu May  9 2013 Paul Howarth <paul@city-fan.org> - 1.04-1
- Update to 1.04
  - Update copyright info
  - Require 5.8 (let me know if this is a problem for you)
  - Improve tests
  - Hopefully fix failing test on Windows
  - Improve code readability
  - Remove DEBUG for private _is_debug method
  - Fix tests to work on older perls
- License changed to Artistic 2.0
- Drop BR: perl(Test::Most), no longer used
- BR: perl(Test::Deep)
- Update patches as needed
- Bump File::Temp version requirement to 0.17 as we use its seek method

* Wed May  8 2013 Paul Howarth <paul@city-fan.org> - 1.02-1
- Update to 1.02
  - Convert to dzil and adopt
- This release by XENO -> update source URL
- Classify buildreqs by usage
- Package new manpage for podspell
- Add buildreqs for author and release tests, and run those tests if we're not
  bootstrapping
- Update UTF8 patch
- Add patches to support building with old Test::More versions

* Mon Jun 11 2012 Paul Howarth <paul@city-fan.org> - 1.01-13
- BR: perl(Carp), perl(constant), perl(Pod::Parser), perl(Test) and
  perl(Text::Wrap)
- Use patch rather than scripted iconv to fix character encoding
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Wed Jun 29 2011 Paul Howarth <paul@city-fan.org> - 1.01-11
- Rebuild for perl 5.14.1 in Rawhide
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 1.01-9
- Rebuild for perl 5.12.1 in Rawhide

* Wed Jun  2 2010 Paul Howarth <paul@city-fan.org> - 1.01-8
- Fix dist tag for RHEL-6 Beta

* Thu Nov 26 2009 Paul Howarth <paul@city-fan.org> - 1.01-7
- Import from Fedora

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.01-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.01-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.01-4
- Rebuild for perl 5.10 (again)

* Sun Jan 13 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.01-3
- Rebuild for new perl

* Tue Oct 16 2007 Tom "spot" Callaway <tcallawa@redhat.com> - 1.01-2.1
- Correct license tag
- Add BR: perl(ExtUtils::MakeMaker)

* Mon Dec 18 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.01-2
- Find: fixed arguments order

* Sun Dec 17 2006 Jose Pedro Oliveira <jpo at di.uminho.pt> - 1.01-1
- First build
